OpenShot Audio Library | OpenShotAudio: juce::WaitableEvent Class Reference

OpenShot Audio Library | OpenShotAudio 0.3.1

Loading...
Searching...
No Matches
Public Member Functions | List of all members
juce::WaitableEvent Class Reference

`#include <juce_WaitableEvent.h>`

## Public Member Functions
| WaitableEvent (bool manualReset=false) noexcept
bool | wait (int timeOutMilliseconds=-1) const
void | signal () const
void | reset () const

## Detailed Description

Allows threads to wait for events triggered by other threads.

A thread can call WaitableEvent::wait() to suspend the calling thread until another thread wakes it up by calling the WaitableEvent::signal() method.

Definition at line 35 of file juce_WaitableEvent.h.

## Constructor & Destructor Documentation

## ◆ WaitableEvent()

juce::WaitableEvent::WaitableEvent | ( | bool | manualReset = `false` | ) |
| explicitnoexcept

Creates a WaitableEvent object.

The object is initially in an unsignalled state.

Parameters

  manualReset | If this is false, the event will be reset automatically when the wait() method is called. If manualReset is true, then once the event is signalled, the only way to reset it will be by calling the reset() method.

Definition at line 26 of file juce_WaitableEvent.cpp.

## Member Function Documentation

## ◆ reset()

void juce::WaitableEvent::reset | ( |  | ) | const

Resets the event to an unsignalled state. If it's not already signalled, this does nothing.

Definition at line 65 of file juce_WaitableEvent.cpp.

Referenced by wait().

## ◆ signal()

void juce::WaitableEvent::signal | ( |  | ) | const

Wakes up any threads that are currently waiting on this object.

If signal() is called when nothing is waiting, the next thread to call wait() will return immediately and reset the signal.

If the WaitableEvent is manual reset, all current and future threads that wait upon this object will be woken, until reset() is explicitly called.

If the WaitableEvent is automatic reset, and one or more threads is waiting upon the object, then one of them will be woken up. If no threads are currently waiting, then the next thread to call wait() will be woken up. As soon as a thread is woken, the signal is automatically reset.

See also
  wait, reset

Definition at line 57 of file juce_WaitableEvent.cpp.

Referenced by juce::ReadWriteLock::exitRead(), juce::ReadWriteLock::exitWrite(), juce::Thread::notify(), and juce::Thread::startThread().

## ◆ wait()

bool juce::WaitableEvent::wait | ( | int | timeOutMilliseconds = `-1` | ) | const

Suspends the calling thread until the event has been signalled.

This will wait until the object's signal() method is called by another thread, or until the timeout expires.

After the event has been signalled, this method will return true and if manualReset was set to false in the WaitableEvent's constructor, then the event will be reset.

Parameters

  timeOutMilliseconds | the maximum time to wait, in milliseconds. A negative value will cause it to wait forever.

Returns
  true if the object has been signalled, false if the timeout expires first.

See also
  signal, reset

Definition at line 31 of file juce_WaitableEvent.cpp.

Referenced by juce::ReadWriteLock::enterRead(), juce::ReadWriteLock::enterWrite(), juce::ThreadPool::removeAllJobs(), juce::Thread::wait(), juce::ThreadPool::waitForJobToFinish(), and juce::BufferingAudioSource::waitForNextAudioBlockReady().

The documentation for this class was generated from the following files:

- juce_WaitableEvent.h
- juce_WaitableEvent.cpp